#include <View.h>
#include <Button.h>
#include <TextControl.h>
#include <Screen.h>
#include <stdio.h>
#include "ssh-askpass.h"

int main()
{
	SshAskPassApp mySshAskPassApp;
	mySshAskPassApp.Run();
	
	return 0;
}

SshAskPassWindow::SshAskPassWindow():
	BWindow(BRect(50,50,50+155,50+55),"Password", B_TITLED_WINDOW, 
	B_ASYNCHRONOUS_CONTROLS | B_NOT_RESIZABLE | B_NOT_ZOOMABLE )
{
	BScreen *Screen = new BScreen( B_MAIN_SCREEN_ID );
	display_mode mode;
	Screen->GetMode( &mode );
	MoveTo( (mode.virtual_width/2)-(Bounds().right/2), 
		(mode.virtual_height/2)-(Bounds().bottom/2) );

	BView *View = new BView(BRect(Bounds()), "View", B_FOLLOW_ALL_SIDES, 
		B_WILL_DRAW );
	View->SetViewColor( 216, 216, 216, 255 );
	AddChild( View );
	
	TextControl = new BTextControl(BRect(5, 5, 150, 80), 
		"TextControl", "Password:", "", (new BMessage('oKBt')));
	TextControl->SetDivider( 55 );
	TextControl->TextView()->HideTyping(true); 
	View->AddChild( TextControl );
	
	BButton *Button = new BButton( BRect(70, 28, 151, 30+16), "Button",
		"Ok", (new BMessage('oKBt')) );
	View->AddChild( Button );
	TextControl->MakeFocus(true);
	
	Activate(true);
}

bool SshAskPassWindow::QuitRequested()
{
	be_app->PostMessage( B_QUIT_REQUESTED );
	return true;
}

void SshAskPassWindow::MessageReceived( BMessage *message )
{
	switch ( message->what )
	{
		case 'oKBt':
			// Button hit!
			printf( "%s", TextControl->TextView()->Text() );
			be_app->PostMessage( B_QUIT_REQUESTED );
			break;
		default:
			BWindow::MessageReceived(message);	
			break;
	}
}

SshAskPassApp::SshAskPassApp():
	BApplication("application/x-vnd.ssh-askpass")
{
	mySshAskPassWindow = new SshAskPassWindow(); 
    mySshAskPassWindow->Show();	
}


